if (window.Worker !== undefined) {
    addEventListener('load', () => {
        var codeBlocks = document.querySelectorAll('.wpd-comment pre.ql-syntax');
        wpDiscuzSyntaxHiglight(codeBlocks);
        if (wpdiscuzAjaxObj.syntaxCustomSelector) {
            var customCodeBlocks = document.querySelectorAll(wpdiscuzAjaxObj.syntaxCustomSelector);
            if(customCodeBlocks instanceof NodeList){
                wpDiscuzSyntaxHiglight(customCodeBlocks);
            }
        }
    });

    var wpdMutationObserver = new MutationObserver(function (mutations) {
        mutations.forEach(function (mutation) {
            if (mutation.type === 'childList' && mutation.addedNodes !== null && typeof mutation.target.classList === "object" && (mutation.target.classList.contains('wpd-comment-text') || mutation.target.classList.contains('wpd-comment-right') || mutation.target.classList.contains('wpd-thread-list'))) {
                mutation.addedNodes.forEach(function (node) {
                    if (typeof node.classList === "object") {
                        if (node.classList.contains('wpd-comment-text') || node.classList.contains('wpd-comment')) {
                            var codeBlocks = node.querySelectorAll('pre.ql-syntax');
                            wpDiscuzSyntaxHiglight(codeBlocks);
                        } else if (node.classList.contains('ql-syntax')) {
                            var codeBlocks = [node];
                            wpDiscuzSyntaxHiglight(codeBlocks);
                        }
                    }
                });
            }
        });
    });

    var wpdcom = document.getElementById('wpdcom');
    wpdMutationObserver.observe(wpdcom, {
        childList: true,
        subtree: true,
    });

    function wpDiscuzSyntaxHiglight(codeBlocks) {
        codeBlocks.forEach(function (codeBlock) {
            if (!codeBlock.classList.contains('hljs')) {
                codeBlock.classList.add('hljs');
            }
            codeBlock.innerHTML = codeBlock.innerHTML.replace(/<br\s*[\/]?>/gi, "\r\n");
            var worker = new Worker(encodeURI(wpdiscuzAjaxObj.syntaxWorkerURL));
            worker.onmessage = (message) => {
                codeBlock.innerHTML = message.data;
                wpDiscuzSyntaxHiglightCopy(codeBlock, codeBlock.textContent);
            }

            worker.postMessage({html: codeBlock.textContent, package: wpdiscuzAjaxObj.syntaxPackage, languages: wpdiscuzAjaxObj.syntaxLanguages});
        });
    }

    function wpDiscuzSyntaxHiglightCopy(el, text){
        let button = Object.assign(document.createElement('button'), {
            innerHTML: wpdiscuzAjaxObj.sx_phrases.copy,
            className: 'hljs-copy-button'
        })
        button.dataset.copied = false
        el.classList.add('hljs-copy-wrapper')
        el.appendChild(button)
        el.style.setProperty('--hljs-theme-background', window.getComputedStyle(el).backgroundColor)
        button.onclick = function () {
            if (!navigator.clipboard) return
            let newText = text
            // if (hook && typeof hook === 'function') {newText = hook(text, el) || text}
            navigator.clipboard.writeText(newText).then(function () {
                button.innerHTML = wpdiscuzAjaxObj.sx_phrases.copied
                button.dataset.copied = true
                let alert = Object.assign(document.createElement('div'), {
                    role: 'status',
                    className: 'hljs-copy-alert',
                    innerHTML: wpdiscuzAjaxObj.sx_phrases.copy_to
                })
                el.appendChild(alert)
                setTimeout(() => {
                    button.innerHTML =  wpdiscuzAjaxObj.sx_phrases.copy
                    button.dataset.copied = false
                    el.removeChild(alert)
                    alert = null
                }, 2e3)
            }).then(function () {if (typeof callback === 'function') return callback(newText, el)})
        }
    }
}
